//package client;

import java.io.*;
import java.net.*;

import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class WebTest {

    private static SimpleReporterAdapter stat
        = new SimpleReporterAdapter("appserver-sqe");
    private static String TEST_NAME = "test";

    private String testSuiteID;
    private String host;
    private String port;
    private String contextRoot;

    public WebTest(String[] args) {
        testSuiteID = args[0];
        host = args[1];
        port = args[2];
        contextRoot = args[3];
        TEST_NAME = testSuiteID;
    }
    
    public static void main(String[] args) {
        stat.addDescription("HelloASync tests for war packaging of EJB components");
        WebTest webTest = new WebTest(args);
        webTest.doTest();
        stat.printSummary(TEST_NAME);
    }

    public void doTest() {     
        try { 
            //test("HelloInvoke");
            test("HelloStatus");
            test("DivideStatus");
            test("DivideExcption");
            test("CompCompute");
            test("FutureArrayObj");
        } catch (Exception ex) {
	    stat.addStatus(TEST_NAME, stat.FAIL);
            ex.printStackTrace();
        }
    }

    private void test(String testcase) throws Exception {
        String EXPECTED_RESPONSE = "Test:Pass";
        String TEST_CASE = TEST_NAME + testcase;
        String url = "http://" + host + ":" + port + contextRoot +  
          "/HelloASyncServlet?tc="+testcase;

        System.out.println("url= "+url);

        HttpURLConnection conn = (HttpURLConnection)
            (new URL(url)).openConnection();
        int code = conn.getResponseCode();
        boolean result = false;
        if (code != 200) {
            System.err.println("Unexpected return code: " + code);
        } else {
            InputStream is = conn.getInputStream();
            BufferedReader input = new BufferedReader(new InputStreamReader(is));
	    String line = null;
	    while ((line = input.readLine()) != null) {
//           System.out.println("line="+line);
	      if (line.contains(EXPECTED_RESPONSE)) {
            result = true;
            break;
	      }
	    }
	    
	    if (line == null) {
	      System.out.println("Unable to find " + EXPECTED_RESPONSE +
				  " in the response");
	    }
        }
        if (result) {
            stat.addStatus(TEST_CASE, stat.PASS);
            System.out.println(testcase +" status = PASS");
        } else {
            stat.addStatus(TEST_CASE, stat.FAIL);
            System.out.println(testcase +" status = FAIL");
        }
    }
}


