package com.sun.ejb31.test;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class HelloASyncServlet extends HttpServlet {
   
    @EJB HelloASyncBean bean;
    
    @EJB Computable comp1;
    
    @EJB AsyncComputable comp2;
    private boolean helloStatus=true, divideStatus = false, 
            divideStatus2 = false, status=false;
    
    /** 
    * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            List<Future<String>> futures = new ArrayList<Future<String>>();
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet HelloASyncServlet</title>");  
            out.println("</head>");
            out.println("<body>");

            out.println("<p>------- HelloASyncServlet --------</p>");
            out.println("HelloASyncServlet at " + request.getContextPath ());
            String testcase = request.getParameter("tc");

            if (testcase != null) {
            out.println("<p>testcase = " + testcase+ "</p>");

            if ("HelloStatus".equals(testcase)){
                for (int i=0; i<6; i++) {
                        bean.someVoidMethod();
                }
            
                for (int i=0; i<6; i++) {
                    futures.add(bean.sayHello(i));
                }

                for (int i=0; i<6; i++) {
                    String value = futures.get(i).get();
                    helloStatus = helloStatus && value.equals("Asynchronous foo got: " + i);
                    out.println("<p> helloStatus = " + value + "</p>");
                    out.println("<p>Hello status: " + helloStatus + "</p>");
                    status = helloStatus;
                }
            }
            
            Future<Double> f1 = null;
            if ("DivideStatus".equals(testcase)){
                try {
                    f1 = bean.divide(6, 0);
                    divideStatus = true;
                } catch (Throwable th) {
                    th.printStackTrace(out);
                    divideStatus = false;
                }
                out.println("<p>Divide status: " + divideStatus + "</p>");
                status = divideStatus;
            }
            out.println("</p>");

            if ("DivideExcption".equals(testcase)){
                Throwable divideEx = null;
                try {
                    f1 = bean.divide(7, 0);
                    f1.get();
                    divideStatus2 = false;
                } catch (ExecutionException divEx) {
                    divideEx = divEx.getCause();
                    divideStatus2 = divideEx instanceof DivideByZeroException;
                } catch (Throwable th) {
                    th.printStackTrace(out);
                    divideStatus2 = false;
                }
                status = divideStatus2;
                out.println("<p>Divide status2: " + divideStatus2 + "</p>");
                out.println("<p>Divide Exception: " + divideEx + "</p>");
            }

            if ("CompCompute".equals(testcase)){
                for (int i=0; i<6; i++) {
                    try {
                        comp1.compute(2, 3);
                        comp2.computeAsync(2, 3);
                        out.println("<p> comp1.compute: " + comp1.compute(2, 3) + "</p>");
                        out.println("<p> comp2.compute: " + comp2.computeAsync(2, 3) + "</p>");
                        status = true;
                    } catch (Exception e) {
                        status = false;
                    }
                }
            }

            if ("FutureArrayObj".equals(testcase)){
                status = false;
                ArrayList<Future<Double>> comps = new ArrayList<Future<Double>>();
                try {
                    for (int i=0; i<6; i++) {
                        comps.add(bean.divide(7, (i+1)));
                        out.println("<p>FutureArrayObj"+i+" STORED </p>");
                    }
                    for (int i=0; i<6; i++) {
                        Double value = comps.get(i).get();
                        out.println("<p>FutureArrayObj"+i+" PASSED :"+value+"</p>");
                    }
                    status = true;
                } catch (DivideByZeroException ex) {
                            ex.printStackTrace(out);
                            status = false;
                            out.println("<p>FutureArrayObj FAILED </p>");
                }
            }
            } else {
                out.println("<p> Please add testcase name in URL! </p>");
            }

            out.println("</body>");
            out.println("</html>");
        } catch (ExecutionException execEx) {execEx.printStackTrace(out);
        } catch (InterruptedException inEx) {
            inEx.printStackTrace(out);
        } finally {
              if (status)
              out.println("Test:Pass");
                else
              out.println("Test:Fail");
            out.close();
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
